# :mailbox: Paper Code Collection (MSRA DKI Group) <img src="https://img-prod-cms-rt-microsoft-com.akamaized.net/cms/api/am/imageFileData/RE1Mu3b?ver=5c31" height="25" align=center>

[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)


This repo hosts multiple open-source codes of the [Microsoft Research Asia DKI Group](https://www.microsoft.com/en-us/research/opportunity/data-analytics-intern-msra-dki/). You could find the corresponding code as below:

## News
- October, 2022 our paper [LEMON: Language-Based Environment Manipulation via Execution-guided Pre-training](https://https://arxiv.org/abs/2201.08081) was accepted by EMNLP 2022 Findings.
- Septempter, 2022 our paper [LogiGAN: Learning Logical Reasoning via Adversarial Pre-training](https://arxiv.org/abs/2205.08794) was accepted by NeurIPS 2022.
- March, 2022: Our paper [Towards Robustness of Text-to-SQL Models Against Natural and Realistic Adversarial Table Perturbation](https://aclanthology.org/2022.acl-long.142.pdf) was accepted by ACL 2022.
- August, 2021: Our paper [Awakening Latent Grounding from Pretrained Language Models for Semantic Parsing](https://aclanthology.org/2021.findings-acl.100.pdf) was accepted by ACL 2021 Findings.
- August, 2021: Our paper [Learning Algebraic Recombination for Compositional Generalization](https://arxiv.org/abs/2107.06516) was accepted by ACL 2021 Findings.
- September, 2020: Our paper ["What Do You Mean by That?" A Parser-Independent Interactive Approach for Enhancing Text-to-SQL](https://arxiv.org/abs/2011.04151) was accepted by EMNLP 2020.
- September, 2020: Our paper [Incomplete Utterance Rewriting as Semantic Segmentation](https://arxiv.org/abs/2009.13166) was accepted by EMNLP 2020.
- September, 2020: Our paper [Hierarchical Poset Decoding for Compositional Generalization in Language](https://arxiv.org/abs/2010.07792) was accepted by NeurIPS 2020.
- September, 2020: Our paper [Compositional Generalization by Learning Analytical Expressions](https://arxiv.org/abs/2006.10627) was accepted by NeurIPS 2020 as *Spotlight*.
- April, 2020: Our paper [How Far are We from Effective Context Modeling ? An Exploratory Study on Semantic Parsing in Context](https://arxiv.org/abs/2002.00652) was accepted by IJCAI 2020.

## Code Release (Click Title to Locate the Code)

### Reasoning
> **[LogiGAN: Learning Logical Reasoning via Adversarial Pre-training](LogiGAN)**
Xinyu Pi*, Wanjun Zhong*, Yan Gao, Nan Duan, Jian-Guang Lou, NeurIPS 2022.

> **[LEMON: Language-Based Environment Manipulation via Execution-guided Pre-training](LEMON)**
Qi Shi, Qian Liu, Bei Chen, Yu Zhang, Ting Liu, Jian-Guang Lou, EMNLP 2022 Findings.

### Text-to-SQL

> **[UniSAr: A Unified Structure-Aware Autoregressive Language Model for Text-to-SQL](unified_parser_text_to_sql)**
> Longxu Dou, Yan Gao, Mingyang Pan, Dingzirui Wang, Wanxiang Che, Dechen Zhan, Jian-Guang Lou, arxiv 2022.

> **[Towards Robustness of Text-to-SQL Models Against Natural and Realistic Adversarial Table Perturbation](robustness_of_text_to_sql)**
> Xinyu Pi*, Bing Wang*, Yan Gao, Jiaqi Guo, Zhoujun Li, Jian-Guang Lou, ACL 2022.

### Compositional Generalization

> **[Learning Algebraic Recombination for Compositional Generalization](https://github.com/thousfeet/LEAR)**
> Chenyao Liu*, Shengnan An*, Zeqi Lin, Qian Liu, Bei Chen, Jian-Guang Lou, Lijie Wen, Nanning Zheng, Dongmei Zhang, ACL 2021 Findings.

> **[Hierarchical Poset Decoding for Compositional Generalization in Language](poset_decoding)**
> Yinuo Guo, Zeqi Lin, Jian-Guang Lou, Dongmei Zhang, NeurIPS 2020.

> **[Compositional Generalization by Learning Analytical Expressions](compositional_generalization)**
> Qian Liu*, Shengnan An*, Jian-Guang Lou, Bei Chen, Zeqi Lin, Yan Gao, Bin Zhou, Nanning Zheng, Dongmei Zhang,  NeurIPS 2020.

### Conversation

> **["What Do You Mean by That?" A Parser-Independent Interactive Approach for Enhancing Text-to-SQL](interactive_text_to_sql)**
> Yuntao Li, Bei Chen, Qian Liu, Yan Gao, Jian-Guang Lou, Yan Zhang, Dongmei Zhang, EMNLP 2020

> **[Incomplete Utterance Rewriting as Semantic Segmentation](incomplete_utterance_rewriting)**
> Qian Liu, Bei Chen, Jian-Guang Lou, Bin Zhou, Dongmei Zhang, EMNLP 2020

> **[How Far are We from Effective Context Modeling ? An Exploratory Study on Semantic Parsing in Context](semantic_parsing_in_context)**
> Qian Liu, Bei Chen, Jiaqi Guo, Jian-Guang Lou, Bin Zhou, Dongmei Zhang, IJCAI 2020

## Contributing

This project welcomes contributions and suggestions.  Most contributions require you to agree to a
Contributor License Agreement (CLA) declaring that you have the right to, and actually do, grant us
the rights to use your contribution. For details, visit https://cla.opensource.microsoft.com.

When you submit a pull request, a CLA bot will automatically determine whether you need to provide
a CLA and decorate the PR appropriately (e.g., status check, comment). Simply follow the instructions
provided by the bot. You will only need to do this once across all repos using our CLA.

This project has adopted the [Microsoft Open Source Code of Conduct](https://opensource.microsoft.com/codeofconduct/).
For more information see the [Code of Conduct FAQ](https://opensource.microsoft.com/codeofconduct/faq/) or
contact [opencode@microsoft.com](mailto:opencode@microsoft.com) with any additional questions or comments.

## Question

If you have any question or find any bug, please go ahead and [open an issue](https://github.com/microsoft/ContextualSP/issues). Issues are an acceptable discussion forum as well.

If you want to concat the author, please email: `qian DOT liu AT buaa.edu.cn`.
